<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>com.sila-standard</groupId>
    <artifactId>sila_edge_gateway</artifactId>
    <version>0.0.1-SNAPSHOT</version>
    <packaging>pom</packaging>

    <name>SiLA Edge Gateway</name>

    <licenses>
        <license>
            <name>MIT License</name>
        </license>
    </licenses>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
        <!-- Compiler Versioning Java 8 -->
        <java.version>1.8</java.version>
        <maven.compiler.source>${java.version}</maven.compiler.source>
        <maven.compiler.target>${java.version}</maven.compiler.target>

        <!-- Common libraries -->
        <slf4j.version>1.7.25</slf4j.version>
        <junit.version>5.0.1</junit.version>
        <logback.version>1.2.3</logback.version>
        <guava.version>30.1-jre</guava.version>
        <jackson.version>2.12.3</jackson.version>

        <!-- gRPC related dependencies -->
        <grpc.version>1.20.0</grpc.version>
        <protobuf.version>3.4.0</protobuf.version>
        <protoc.maven.version>3.5.1.1</protoc.maven.version>
        <sila_base.path>common/sila_java/library/sila_base/src/main/resources/sila_base</sila_base.path>

        <!-- Packaging -->
        <spring.version>2.0.3.RELEASE</spring.version>
    </properties>

    <modules>
        <module>gateway</module>
        <module>examples</module>
        <module>common</module>
    </modules>

    <dependencies>
        <!-- Application Dependencies -->
        <dependency>
            <groupId>com.google.guava</groupId>
            <artifactId>guava</artifactId>
            <version>${guava.version}</version>
        </dependency>
        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>RELEASE</version>
            <scope>compile</scope>
        </dependency>

        <!-- Testing -->
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter-api</artifactId>
            <version>${junit.version}</version>
            <scope>test</scope>
        </dependency>
    </dependencies>
    <build>
        <pluginManagement>
            <!-- Packaging -->
            <plugins>
                <plugin>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-maven-plugin</artifactId>
                    <version>${spring.version}</version>
                    <configuration>
                        <finalName>${project.artifactId}</finalName>
                        <classifier>exec</classifier>
                        <layout>JAR</layout>
                    </configuration>
                    <executions>
                        <execution>
                            <goals>
                                <goal>repackage</goal>
                            </goals>
                        </execution>
                    </executions>
                </plugin>
            </plugins>
        </pluginManagement>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-source-plugin</artifactId>
                <version>3.0.1</version>
                <executions>
                    <execution>
                        <id>attach-sources</id>
                        <phase>deploy</phase>
                        <goals>
                            <goal>jar-no-fork</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>